unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MathEdit, Buttons;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    CB_KeepBlanks: TCheckBox;
    CB_KeepPunct: TCheckBox;
    Edit3: TEdit;
    Memo1: TMemo;
    Memo2: TMemo;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
    function encrypted(c: Char; n: Integer): Char;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function TForm1.encrypted(c: Char; n: Integer): Char;
  var b : Byte;
  begin
  If c in ['A'..'Z', 'a'..'z'] then begin   { Normale Buchstaben verschlsseln }
    b := BYTE(Upcase(c)) - BYTE('A');
    b := (b + n) Mod 26;                    { Verschieben um n, Mod 26 }
    Result := CHAR(b + BYTE('A'));
    end
  else if (c = ' ') then                    { Sonderbehandlung fr Leerzeichen }
    If CB_KeepBlanks.Checked then
      Result := ' '                            { beibehalten  }
    else
      Result := #0                             { oder lschen }
  else
    If CB_KeepPunct.Checked or              { Sonderbehandlung fr Satzzeichen }
       (BYTE(c) < 32) then
      Result := c                               { beibehalten }
    else
      Result := #0;                             { oder lschen }
  end;

procedure TForm1.Button1Click(Sender: TObject);
  var kt, gt, s : String;   { Klartext, Geheimtext, Schlssel (Key) }
      c   : Char;           { "c_rypted character" }
      n,                    { Index des aktuellen Key-Buchstabens im Schlssel }
      v,                    { Verschiebung }
      i   : Integer;
  begin
  Memo2.Lines.Text := '';       { Ziel-Memo leeren }
  s  := UpperCase(Edit3.Text);  { Schlsselphrase in Grobuchstaben verwandeln }
  n  := 1;                      { Schlssel-Index zeigt auf erstes Key-Char    }
  gt := '';                     { Geheimtext-Puffer leeren }
  kt := Memo1.Lines.Text;       { Klartext holen   }
  For i := 1 to Length(kt) do begin
    v := BYTE(s[n]) - BYTE('A');     { Aktuelle Verschiebung berechnen   }
    c := encrypted(kt[i], v);        { Verschlsseln  }
    If c <> #0 then begin
      gt := gt + c;                  { Zeichen zum Geheimtext hinzufgen }
      If c in ['A'..'Z'] then begin  { Falls echter Buchstabe:           }
        n  := n + 1;                 {   Neuen Schlsselindex berechnen! }
        If n > Length(s) then
          n := 1;
        end;
      end;
    end;
  Memo2.Lines.Text := gt;       { Geheimtext anzeigen }
  end;

procedure TForm1.Button2Click(Sender: TObject);
  var kt, gt, s : String;   { Klartext, Geheimtext, Schlssel (Key) }
      d   : Char;           { "d_ecrypted character" }
      n,                    { Index des aktuellen Key-Buchstabens im Schlssel }
      v,                    { Verschiebung }
      i   : Integer;
  begin
  Memo1.Lines.Text := '';       { Ziel-Memo leeren }
  s  := UpperCase(Edit3.Text);  { Schlsselphrase in Grobuchstaben verwandeln }
  n  := 1;                      { Schlssel-Index zeigt auf erstes Key-Char    }
  kt := '';                     { Klartext-Puffer leeren }
  gt := Memo2.Lines.Text;       { Geheimtext holen   }
  For i := 1 to Length(gt) do begin
    v := 26 - (Ord(s[n]) - Ord('A'));      { Aktuelle Verschiebung berechnen   }
    d := encrypted(gt[i], v);              { Entschlsseln  }
    If d <> #0 then begin
      kt := kt + d;                        { Zeichen zum Klartext hinzufgen   }
      If d in ['A'..'Z'] then begin        { Falls echter Buchstabe:           }
        n  := n + 1;                       {   Neuen Schlsselindex berechnen! }
        If n > Length(s) then
          n := 1;
        end;
      end;
    end;
  Memo1.Lines.Text := kt;       { Klartext anzeigen }
  end;

end.
